CPG_DISPATCH(3)

NAME
cpg_dispatch - Dispatches callbacks from the CPG service

SYNOPSIS
#include <corosync/cpg.h>

int cpg_dispatch(cpg_handle_t handle, cpg_dispatch_t *dispatch_types);

DESCRIPTION
The cpg_dispatch function is used to dispatch configuration changes or messages from the closed process groups API.

Each application may have several connections to the CPG API. Each application uses the handle argument to uniquely identify the connection.

The dispatch_types argument is used to identify the type of dispatch to execute. The possible types are defined by the structure:

    typedef enum {
            CS_DISPATCH_ONE,
            CS_DISPATCH_ALL,
            CS_DISPATCH_BLOCKING
    } cpg_dispatch_t;

The dispatch values have the following meanings:

CS_DISPATCH_ONE
    Dispatch atleast one callback, blocking until the callback is dispatched.

CS_DISPATCH_ALL
    Dispatch all waiting callbacks without blocking to wait for any callbacks.

CS_DISPATCH_BLOCKING
    Dispatch all callbacks, blocking indefinitely. This is used in a threaded program where a thread is created, and then cpg_dispatch() is called immediately from the created thread to execute callbacks.

CS_DISPATCH_ONE_NONBLOCKING
    Dispatch at most one callback. If there is no pending callback, CS_ERR_TRY_AGAIN is returned.

RETURN VALUE
This call returns the CS_OK value if successful, otherwise an error is returned.

ERRORS
The errors are undocumented.

SEE ALSO
cpg_overview(8), cpg_initialize(3), cpg_finalize(3), cpg_fd_get(3), cpg_dispatch(3), cpg_join(3), cpg_leave(3), cpg_mcast_joined(3), cpg_membership_get(3) cpg_zcb_alloc(3) cpg_zcb_free(3) cpg_zcb_mcast_joined(3) cpg_context_get(3) cpg_context_set(3) cpg_local_get(3)